﻿using System;
using System.Collections;
using WebApiStudy.Model;
using WebApiStudy.IDal;
using System.Collections.Generic;
using System.Linq;

namespace WebApiStudy.Dal
{
    public class UserDal : IUserDal
    {
        private List<User> users;

        public UserDal()
        {
            users = new List<User>()
            {
                new User(){ Id=3, Name="张三", Gender=1, Age=23 },
                new User(){ Id=4, Name="李四", Gender=0, Age=24 },
                new User(){ Id=5, Name="王五", Gender=1, Age=25 },
                new User(){ Id=6, Name="赵六", Gender=0, Age=26 },
                new User(){ Id=7, Name="周七", Gender=1, Age=27 },
             };
        }

        public List<User> GetAllUser()
        {
            return users;
        }

        public User GetUser(int userId)
        {
            var findUser = users.FirstOrDefault(u => u.Id == userId);

            return findUser;
        }

        public (bool result, User user) InsertUser(User user)
        {
            var findUser = users.FirstOrDefault(u => u.Id == user.Id);
            if (findUser == null)
            {
                users.Add(user);
            }

            var result = ValueTuple.Create(findUser == null, user);
            return result;
        }

        public (bool result, User user) UpdateUser(User user)
        {
            var findUser = users.FirstOrDefault(u => u.Id == user.Id);
            if (findUser != null)
            {
                users.Remove(findUser);
                users.Add(user);
            }

            var result = ValueTuple.Create(findUser != null, user);
            return result;
        }

        public int DeleteUser(int userId)
        {
            var findUser = users.FirstOrDefault(u => u.Id == userId);
            if (findUser != null)
            {
                users.Remove(findUser);
            }

            var result = findUser == null ? 0 : 1;
            return result;
        }
    }
}
