﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;

using WebApiStudy.Model;
using WebApiStudy.IDal;
using WebApiStudy.IBll;

namespace WebApiStudy.WebApp.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class UserController : ControllerBase
    {
        IUserBll userBll;

        public UserController(IUserBll userBll)
        {
            this.userBll = userBll;
        }

        [HttpGet("GetAllUser")]
        public List<User> GetUsers()
        {
            return userBll.GetAllUser();
        }

        [HttpGet("GetUser/{userId:int}")]
        public User GetUser(int userId)
        {
            return userBll.GetUser(userId);
        }

        [HttpPost("AddUser")]
        public (bool result, User user) InsertUser([FromBody]User user)
        {
            return userBll.InsertUser(user);
        }

        [HttpPost("UpdateUser")]
        public (bool result, User user) UpdateUser([FromBody]User user)
        {
            return userBll.UpdateUser(user);
        }

        [HttpDelete("UpdateUser/{userId}")]
        public bool DeleteUser(int userId)
        {
            return userBll.DeleteUser(userId);
        }

        [HttpGet("GetIncome/{userId:int}")]
        public decimal TotalIncome(int userId)
        {
            return userBll.TotalIncome(userId);
        }

        [HttpGet("GetCost/{userId:int}")]
        public decimal TotalCost(int userId)
        {
            return userBll.TotalCost(userId);
        }
    }
}